(function() {
  exports.add = function(store, actionType, actionData) {
    return store.push(actionData);
  };

  exports.update = function(store, actionType, actionData) {
    var id, text;
    id = actionData.get("id");
    text = actionData.get("text");
    return store.map(function(task) {
      if (task.get("id") === id) {
        return task.set("text", text);
      } else {
        return task;
      }
    });
  };

  exports.toggle = function(store, actionType, actionData) {
    store;
    var id;
    id = actionData;
    return store.map(function(task) {
      if (task.get("id") === id) {
        return task.update("done", function(done) {
          return !done;
        });
      } else {
        return task;
      }
    });
  };

  exports.remove = function(store, actionType, actionData) {
    var id;
    id = actionData;
    return store.filterNot(function(task) {
      return task.get("id") === id;
    });
  };

}).call(this);
