(function() {
  var Immutable, React, classnames, div, pre;

  React = require("react");

  Immutable = require("immutable");

  classnames = require("classnames");

  div = React.createFactory("div");

  pre = React.createFactory("pre");

  module.exports = React.createClass({
    displayName: "recorder-item",
    propTypes: {
      index: React.PropTypes.number.isRequired,
      record: React.PropTypes.instanceOf(Immutable.List),
      isPointer: React.PropTypes.bool.isRequired,
      onPeek: React.PropTypes.func.isRequired
    },
    onClick: function() {
      return this.props.onPeek(this.props.index);
    },
    render: function() {
      var actionData, actionType, className;
      actionType = this.props.record.get(0);
      actionData = this.props.record.get(1);
      className = classnames("recorder-item", {
        "is-pointer": this.props.isPointer
      });
      return div({
        className: className,
        onClick: this.onClick
      }, div({
        className: "record-title"
      }, actionType), pre({
        className: "record-content"
      }, JSON.stringify(actionData, null, 2)));
    }
  });

}).call(this);
